package PZ::Helpers::Octopus;

use strict;
use warnings;

use base 'Mojolicious::Plugin';
use Mojo::JWT;

sub register {
    my ($class, $self) = @_;

    $self->helper( octopus_auth => sub {
        my $c     = shift;
        my $token = shift // return undef;

        my $claims;

        eval {
            $claims = Mojo::JWT->new(
                secret => $self->cfg->{octopus}{secret}
            )->decode($token);
        };

        if ( $@ ) {
            $c->app->log->warn( $@ );
            return undef;
        }

        my $user = $c->schema->resultset('User')->update_or_create(
            uuid => $claims->{uuid},
            { key => 'uuid', }
        );

        $user->set_token;

        return $user->token;
    });

}

1;

__END__
