package PZ::Schema::Result::Log;

use strict;
use warnings;

use base 'DBIx::Class::Core';

our $VERSION = 1;

__PACKAGE__->table('log');

__PACKAGE__->add_columns(
    id => {
        data_type         => 'integer',
        is_auto_increment => 1,
        is_nullable       => 0,
        sequence          => 'uid_seq'
    },
    qw(
        time
        shortcut_id
        ip
        ua
        referrer
    ),
);

sub anonymized_ip {
    my $self = shift;

    my $ip = $self->ip;
    $ip =~ s/\d+\.\d+$/X.X/;

    return $ip;
}

__PACKAGE__->set_primary_key('id');

1;


